"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var compiler_1 = require("@angular/compiler");
var JitReflector_1 = require("./JitReflector");
var pipes = [
    'async',
    'currency',
    'date',
    'number',
    'percent',
    'i18nSelect',
    'i18nPlural',
    'json',
    'lowercase',
    'slice',
    'titlecase',
    'uppercase',
    'safe',
    'utcDate'
].map(function (name, index) {
    return {
        type: {
            diDeps: [],
            lifecycleHooks: [],
            reference: "pipe-" + index
        },
        isComponent: false,
        name: name,
        pure: true,
        summaryKind: compiler_1.CompileSummaryKind.Pipe
    };
});
var directives = [
    {
        selector: 'form:not([ngNoForm]):not([formGroup]), ngForm, [ngForm]',
        exportAs: 'ngForm'
    },
    { selector: '[routerLinkActive]', exportAs: 'routerLinkActive' },
    {
        selector: '[ngModel]:not([formControlName]):not([formControl])',
        exportAs: 'ngModel'
    },
    { selector: '[ngIf]', exportAs: 'ngIf', inputs: ['ngIf'] },
    {
        selector: '[ngFor][ngForOf]',
        exportAs: 'ngFor',
        inputs: ['ngForTemplate', 'ngForOf']
    },
    { selector: '[ngSwitch]', exportAs: 'ngSwitch', inputs: ['ngSwitch'] },
    {
        selector: '[ngSwitchCase]',
        exportAs: 'ngSwitchCase',
        inputs: ['ngSwitchCase']
    },
    {
        selector: '[ngSwitchDefault]',
        exportAs: 'ngSwitchDefault',
        inputs: ['ngSwitchDefault']
    }
].map(function (directive, index) {
    var selector = directive.selector, exportAs = directive.exportAs, _a = directive.inputs, inputs = _a === void 0 ? [] : _a;
    return {
        type: {
            diDeps: [],
            lifecycleHooks: [],
            reference: "directive-" + index
        },
        isComponent: false,
        selector: selector,
        exportAs: exportAs,
        inputs: inputs,
        outputs: {},
        isSummary: true,
        guards: [],
        hostListeners: {},
        hostProperties: {},
        hostAttributes: {},
        providers: [],
        viewQueries: [],
        viewProviders: [],
        queries: [],
        entryComponents: [],
        changeDetection: 0,
        componentViewType: null,
        rendererType: null,
        componentFactory: null,
        summaryKind: compiler_1.CompileSummaryKind.Directive,
        template: {
            isSummary: true,
            animations: [],
            styles: [],
            ngContentSelectors: [],
            encapsulation: 0
        }
    };
});
function parseTemplate(template) {
    var templateParser = new compiler_1.TemplateParser(new compiler_1.CompilerConfig({}), new JitReflector_1.JitReflector(), new compiler_1.Parser(new compiler_1.Lexer()), new compiler_1.DomElementSchemaRegistry(), new compiler_1.I18NHtmlParser(new compiler_1.HtmlParser()), {
        log: function (message) { },
        warn: function (message) { }
    }, []);
    return templateParser.parse(compiler_1.CompileDirectiveMetadata.create({
        isHost: true,
        isComponent: true,
        selector: '',
        exportAs: '',
        changeDetection: core_1.ChangeDetectionStrategy.Default,
        inputs: [],
        outputs: [],
        host: {},
        providers: [],
        viewProviders: [],
        queries: [],
        viewQueries: [],
        entryComponents: [],
        guards: [],
        componentViewType: null,
        rendererType: null,
        componentFactory: null,
        type: {
            diDeps: [],
            lifecycleHooks: [],
            reference: null
        },
        template: {
            encapsulation: 0,
            template: template,
            templateUrl: '',
            styles: [],
            isInline: true,
            styleUrls: [],
            ngContentSelectors: [],
            animations: [],
            externalStylesheets: [],
            interpolation: null,
            preserveWhitespaces: true,
            htmlAst: null,
            toSummary: function () {
                return {
                    isSummary: true,
                    animations: [],
                    styles: [],
                    ngContentSelectors: [],
                    encapsulation: 0,
                    summaryKind: 0
                };
            }
        }
    }), template, directives, pipes, [core_1.NO_ERRORS_SCHEMA], '', true);
}
exports.parseTemplate = parseTemplate;
//# sourceMappingURL=parseTemplate.js.map