"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var autocomplete_1 = require("primeng/autocomplete");
var get = require("lodash/get");
var set = require("lodash/set");
var template_form_1 = require("./template-form");
var AutoCompleteComponent = /** @class */ (function (_super) {
    __extends(AutoCompleteComponent, _super);
    function AutoCompleteComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.style = {};
        _this.search = new core_1.EventEmitter();
        _this.select = new core_1.EventEmitter();
        return _this;
    }
    AutoCompleteComponent_1 = AutoCompleteComponent;
    Object.defineProperty(AutoCompleteComponent.prototype, "value", {
        get: function () {
            return this.innerValue;
        },
        set: function (value) {
            var _this = this;
            if (value != this.innerValue) {
                this.innerValue = value;
                this.onChange(value);
                if (this.textProperty && this.data) {
                    var item = this.data.find(function (item) { return get(item, _this.textProperty) == value; });
                    if (!item) {
                        item = {};
                        set(item, this.textProperty, value);
                    }
                    this.change.next(item);
                }
                else {
                    this.change.next(value);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    AutoCompleteComponent.prototype.onSearch = function (event) {
        this.search.next(new AutoCompleteLoadData(event.query, this));
    };
    AutoCompleteComponent.prototype.onSelect = function (event) {
        this.select.next(event);
    };
    var AutoCompleteComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], AutoCompleteComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], AutoCompleteComponent.prototype, "placeholder", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], AutoCompleteComponent.prototype, "textProperty", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], AutoCompleteComponent.prototype, "search", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], AutoCompleteComponent.prototype, "select", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], AutoCompleteComponent.prototype, "value", null);
    AutoCompleteComponent = AutoCompleteComponent_1 = __decorate([
        core_1.Component({
            selector: 'rz-autocomplete',
            template: "\n    <p-autoComplete\n      appendTo=\"body\"\n      [(ngModel)]=\"value\"\n      [style]=\"style\"\n      [placeholder]=\"placeholder\"\n      [inputId]=\"name\"\n      [suggestions]=\"suggestions\"\n      [disabled]=\"disabled\"\n      (blur)=\"onTouched()\"\n      (onSelect)=\"onSelect($event)\"\n      (completeMethod)=\"onSearch($event)\"\n    >\n    </p-autoComplete>\n  ",
            providers: [
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return AutoCompleteComponent_1; }),
                    multi: true
                },
                {
                    provide: template_form_1.InputComponent,
                    useExisting: core_1.forwardRef(function () { return AutoCompleteComponent_1; })
                }
            ]
        })
    ], AutoCompleteComponent);
    return AutoCompleteComponent;
}(template_form_1.InputComponent));
exports.AutoCompleteComponent = AutoCompleteComponent;
var AutoCompleteLoadData = /** @class */ (function () {
    function AutoCompleteLoadData(text, autoComplete) {
        this.text = text;
        this.autoComplete = autoComplete;
    }
    Object.defineProperty(AutoCompleteLoadData.prototype, "data", {
        get: function () {
            return this.autoComplete.data;
        },
        set: function (value) {
            var _this = this;
            this.autoComplete.data = value;
            this.autoComplete.suggestions = this.autoComplete.textProperty ?
                value.map(function (item) { return get(item, _this.autoComplete.textProperty); }) : value;
        },
        enumerable: true,
        configurable: true
    });
    return AutoCompleteLoadData;
}());
var AutoCompleteModule = /** @class */ (function () {
    function AutoCompleteModule() {
    }
    AutoCompleteModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, forms_1.FormsModule, autocomplete_1.AutoCompleteModule],
            declarations: [AutoCompleteComponent],
            exports: [AutoCompleteComponent]
        })
    ], AutoCompleteModule);
    return AutoCompleteModule;
}());
exports.AutoCompleteModule = AutoCompleteModule;
