"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var ButtonComponent = /** @class */ (function () {
    function ButtonComponent() {
        this.text = '';
        this.tooltip = '';
        this.size = 'md';
        this.buttonStyle = 'primary';
        this.click = new core_1.EventEmitter();
        this.style = {};
        this.disabled = false;
        this.buttonType = 'button';
        this.classList = {};
    }
    ButtonComponent.prototype.onClick = function (event) {
        event.stopPropagation();
        if (!this.disabled) {
            this.click.next();
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], ButtonComponent.prototype, "text", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], ButtonComponent.prototype, "tooltip", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], ButtonComponent.prototype, "icon", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], ButtonComponent.prototype, "size", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], ButtonComponent.prototype, "buttonStyle", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ButtonComponent.prototype, "click", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], ButtonComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], ButtonComponent.prototype, "disabled", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], ButtonComponent.prototype, "buttonType", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], ButtonComponent.prototype, "classList", void 0);
    ButtonComponent = __decorate([
        core_1.Component({
            selector: 'rz-button',
            template: "\n    <button\n      [ngStyle]=\"style\"\n      class=\"ui-button ui-button-{{\n        size\n      }} ui-widget ui-state-default ui-corner-all btn-{{ buttonStyle }}\"\n      [type]=\"buttonType\"\n      [title]=\"tooltip\"\n      [disabled]=\"disabled\"\n      [class.ui-state-disabled]=\"disabled\"\n      [class.ui-button-text-icon-left]=\"icon && text\"\n      [class.ui-button-icon-only]=\"icon && !text\"\n      [ngClass]=\"classList\"\n      (click)=\"onClick($event)\"\n    >\n      <i\n        (click)=\"onClick($event)\"\n        *ngIf=\"icon\"\n        class=\"ui-button-icon-left pi fa\"\n        >{{ icon }}</i\n      >\n      <span (click)=\"onClick($event)\" *ngIf=\"text\" class=\"ui-button-text\">{{\n        text\n      }}</span>\n    </button>\n  ",
        })
    ], ButtonComponent);
    return ButtonComponent;
}());
exports.ButtonComponent = ButtonComponent;
var ButtonModule = /** @class */ (function () {
    function ButtonModule() {
    }
    ButtonModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule],
            declarations: [ButtonComponent],
            exports: [ButtonComponent],
        })
    ], ButtonModule);
    return ButtonModule;
}());
exports.ButtonModule = ButtonModule;
