"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var rxjs_1 = require("rxjs");
var dialog_1 = require("./dialog");
var ContentService = /** @class */ (function () {
    function ContentService() {
        this.contentRegistered$ = new rxjs_1.Subject();
    }
    ContentService.prototype.afterContentRegistered = function () {
        return this.contentRegistered$.asObservable();
    };
    ContentService.prototype.registerContent = function (content) {
        this.contentRegistered$.next(content);
    };
    ContentService = __decorate([
        core_1.Injectable()
    ], ContentService);
    return ContentService;
}());
exports.ContentService = ContentService;
var ContentComponent = /** @class */ (function () {
    function ContentComponent(containerRef, contentService, dialogRef) {
        this.containerRef = containerRef;
        this.contentService = contentService;
        this.dialogRef = dialogRef;
    }
    ContentComponent.prototype.ngOnInit = function () {
        if (this.dialogRef == null) {
            // Do not register if displayed inside a dialog
            this.contentService.registerContent({
                container: this.container,
                elementRef: this.containerRef.element
            });
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], ContentComponent.prototype, "container", void 0);
    ContentComponent = __decorate([
        core_1.Component({
            selector: 'rz-content',
            template: '<div class="content"><ng-content></ng-content></div>'
        }),
        __param(2, core_1.Optional()),
        __metadata("design:paramtypes", [core_1.ViewContainerRef,
            ContentService,
            dialog_1.DialogRef])
    ], ContentComponent);
    return ContentComponent;
}());
exports.ContentComponent = ContentComponent;
var ContentModule = /** @class */ (function () {
    function ContentModule() {
    }
    ContentModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, dialog_1.DialogModule],
            declarations: [ContentComponent],
            providers: [ContentService],
            exports: [ContentComponent]
        })
    ], ContentModule);
    return ContentModule;
}());
exports.ContentModule = ContentModule;
