"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var operators_1 = require("rxjs/operators");
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var rxjs_1 = require("rxjs");
var document_token_1 = require("./document.token");
var LayoutService = /** @class */ (function () {
    function LayoutService(injector, zone) {
        var _this = this;
        this.injector = injector;
        this.headerHeight = new rxjs_1.BehaviorSubject(0);
        this.footerHeight = new rxjs_1.BehaviorSubject(0);
        this.sidebarStretch = new rxjs_1.BehaviorSubject(false);
        this.sidebarWidth = new rxjs_1.BehaviorSubject(0);
        var mediaQuery = this.deviceMediaQuery();
        this.sidebarOpen = new rxjs_1.BehaviorSubject(!mediaQuery.matches);
        mediaQuery.addListener(function (_a) {
            var matches = _a.matches;
            zone.run(function () {
                _this.sidebarOpen.next(!matches);
            });
        });
    }
    LayoutService.prototype.toggleSidebar = function () {
        var open = this.sidebarOpen.getValue();
        this.sidebarOpen.next(!open);
    };
    LayoutService.prototype.deviceMediaQuery = function () {
        var defaultView = this.injector.get(document_token_1.DOCUMENT_TOKEN, document).defaultView;
        if (defaultView.matchMedia) {
            var mediaQuery = defaultView.matchMedia('(max-width: 768px)');
            return mediaQuery;
        }
        else {
            return {
                addListener: function (callback) { },
                get matches() {
                    return defaultView.innerWidth > 768;
                }
            };
        }
    };
    LayoutService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [core_1.Injector, core_1.NgZone])
    ], LayoutService);
    return LayoutService;
}());
exports.LayoutService = LayoutService;
var OffsetBySidebarDirective = /** @class */ (function () {
    function OffsetBySidebarDirective(layoutService) {
        var _this = this;
        this.force = false;
        this.ngUnsubscribe = new rxjs_1.Subject();
        layoutService.sidebarOpen.pipe(operators_1.combineLatest(layoutService.sidebarStretch, layoutService.sidebarWidth), operators_1.takeUntil(this.ngUnsubscribe))
            .subscribe(function (value) {
            var sidebarOpen = value[0], sidebarStretch = value[1], sidebarWidth = value[2];
            _this.sidebarOpen = sidebarOpen;
            _this.sidebarStretch = sidebarStretch;
            _this.sidebarWidth = sidebarWidth;
            if (_this.sidebarOpen && (_this.sidebarStretch || _this.force)) {
                _this.marginLeft = _this.sidebarWidth;
            }
            else {
                _this.marginLeft = 0;
            }
        });
    }
    OffsetBySidebarDirective.prototype.ngOnDestroy = function () {
        this.ngUnsubscribe.next();
        this.ngUnsubscribe.complete();
    };
    __decorate([
        core_1.Input('rz-offset-by-sidebar'),
        __metadata("design:type", Object)
    ], OffsetBySidebarDirective.prototype, "force", void 0);
    __decorate([
        core_1.HostBinding('style.marginLeft.px'),
        __metadata("design:type", Number)
    ], OffsetBySidebarDirective.prototype, "marginLeft", void 0);
    OffsetBySidebarDirective = __decorate([
        core_1.Directive({
            selector: '[rz-offset-by-sidebar]'
        }),
        __metadata("design:paramtypes", [LayoutService])
    ], OffsetBySidebarDirective);
    return OffsetBySidebarDirective;
}());
exports.OffsetBySidebarDirective = OffsetBySidebarDirective;
var LayoutModule = /** @class */ (function () {
    function LayoutModule() {
    }
    LayoutModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule],
            declarations: [OffsetBySidebarDirective],
            providers: [LayoutService],
            exports: [OffsetBySidebarDirective]
        })
    ], LayoutModule);
    return LayoutModule;
}());
exports.LayoutModule = LayoutModule;
