"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var panel_1 = require("primeng/panel");
var PanelHeaderComponent = /** @class */ (function () {
    function PanelHeaderComponent() {
    }
    PanelHeaderComponent = __decorate([
        core_1.Component({
            selector: 'rz-panel-header',
            template: "\n    <ng-content></ng-content>\n  "
        })
    ], PanelHeaderComponent);
    return PanelHeaderComponent;
}());
exports.PanelHeaderComponent = PanelHeaderComponent;
var PanelFooterComponent = /** @class */ (function () {
    function PanelFooterComponent() {
    }
    PanelFooterComponent = __decorate([
        core_1.Component({
            selector: 'rz-panel-footer',
            template: "\n    <ng-content></ng-content>\n  "
        })
    ], PanelFooterComponent);
    return PanelFooterComponent;
}());
exports.PanelFooterComponent = PanelFooterComponent;
var PanelComponent = /** @class */ (function () {
    function PanelComponent(elementRef) {
        this.style = {};
        this.allowCollapse = false;
        this.collapsed = false;
        this.expand = new core_1.EventEmitter();
        this.collapse = new core_1.EventEmitter();
        this.elementRef = elementRef;
    }
    PanelComponent.prototype.onToggle = function (event) {
        if (event.collapsed) {
            this.collapse.next();
        }
        else {
            this.expand.next();
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], PanelComponent.prototype, "text", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], PanelComponent.prototype, "icon", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], PanelComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], PanelComponent.prototype, "allowCollapse", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], PanelComponent.prototype, "collapsed", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], PanelComponent.prototype, "expand", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], PanelComponent.prototype, "collapse", void 0);
    PanelComponent = __decorate([
        core_1.Component({
            selector: 'rz-panel',
            template: "\n    <p-panel\n      (onAfterToggle)=\"onToggle($event)\"\n      [style]=\"style\"\n      [(collapsed)]=\"collapsed\"\n      [toggleable]=\"allowCollapse\"\n      [header]=\"icon ? null : text\"\n    >\n      <p-header *ngIf=\"icon\">\n        <i class=\"material-icons\">{{ icon }}</i\n        ><span class=\"material-icons-label\">{{ text }}</span>\n      </p-header>\n      <p-header> <ng-content select=\"rz-panel-header\"></ng-content> </p-header>\n      <p-footer> <ng-content select=\"rz-panel-footer\"></ng-content> </p-footer>\n      <ng-content></ng-content>\n    </p-panel>\n  "
        }),
        __metadata("design:paramtypes", [core_1.ElementRef])
    ], PanelComponent);
    return PanelComponent;
}());
exports.PanelComponent = PanelComponent;
var PanelModule = /** @class */ (function () {
    function PanelModule() {
    }
    PanelModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, panel_1.PanelModule],
            declarations: [PanelComponent, PanelFooterComponent, PanelHeaderComponent],
            exports: [PanelComponent, PanelFooterComponent, PanelHeaderComponent]
        })
    ], PanelModule);
    return PanelModule;
}());
exports.PanelModule = PanelModule;
