"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var get = require("lodash/get");
var ngx_charts_1 = require("@swimlane/ngx-charts");
var shared_1 = require("./shared");
var PieComponent = /** @class */ (function () {
    function PieComponent() {
        this.style = {};
        this.colors = [
            '#479cc8',
            '#68D5C8',
            '#ff6d41',
            '#cb6992',
            '#e6c54f',
            '#f9777f',
            '#5dbf74',
            '#4db9f2',
            '#FF6D41'
        ];
        this.select = new core_1.EventEmitter();
        this.results = [];
    }
    PieComponent.prototype.onSelect = function (event) {
        if (typeof event != 'string') {
            this.select.emit({ category: event.name, value: event.value });
        }
    };
    PieComponent.prototype.ngOnInit = function () {
        this.update();
    };
    PieComponent.prototype.ngOnChanges = function () {
        this.update();
    };
    PieComponent.prototype.update = function () {
        var _this = this;
        if (this.data && this.categoryProperty && this.valueProperty) {
            var series = this.data.map(function (item) {
                return {
                    name: get(item, _this.categoryProperty),
                    value: get(item, _this.valueProperty)
                };
            });
            this.results = series;
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], PieComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], PieComponent.prototype, "title", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], PieComponent.prototype, "icon", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], PieComponent.prototype, "titleBackground", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], PieComponent.prototype, "titleColor", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], PieComponent.prototype, "chartType", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], PieComponent.prototype, "data", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], PieComponent.prototype, "categoryProperty", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], PieComponent.prototype, "valueProperty", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], PieComponent.prototype, "legend", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], PieComponent.prototype, "labels", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], PieComponent.prototype, "colors", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], PieComponent.prototype, "select", void 0);
    PieComponent = __decorate([
        core_1.Component({
            selector: 'rz-pie',
            host: {
                style: 'display: block; height: 100%'
            },
            template: "<div #container class=\"pie\" [ngStyle]=\"style\">\n      <ngx-charts-pie-chart\n        [scheme]=\"{domain:colors}\"\n        [animations]=\"false\"\n        [results]=\"results\"\n        [legend]=\"legend\"\n        [labels]=\"labels\"\n        (select)=\"onSelect($event)\"\n        [doughnut]=\"chartType == 'Donut'\"\n      ></ngx-charts-pie-chart>\n    </div>"
        })
    ], PieComponent);
    return PieComponent;
}());
exports.PieComponent = PieComponent;
var PieModule = /** @class */ (function () {
    function PieModule() {
    }
    PieModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, ngx_charts_1.NgxChartsModule, shared_1.SharedModule],
            declarations: [PieComponent],
            exports: [PieComponent]
        })
    ], PieModule);
    return PieModule;
}());
exports.PieModule = PieModule;
