"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
var button_1 = require("primeng/button");
var template_form_1 = require("./template-form");
var SignatureComponent = /** @class */ (function (_super) {
    __extends(SignatureComponent, _super);
    function SignatureComponent(templateForm) {
        var _this = _super.call(this, templateForm) || this;
        _this.style = {};
        _this.isEmpty = true;
        return _this;
    }
    SignatureComponent_1 = SignatureComponent;
    Object.defineProperty(SignatureComponent.prototype, "value", {
        get: function () {
            if (this.signaturePad) {
                this.isEmpty = this.signaturePad.isEmpty();
                return this.signaturePad.toDataURL();
            }
            return this.innerValue;
        },
        set: function (value) {
            if (value != this.innerValue) {
                this.innerValue = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    SignatureComponent.prototype.writeValue = function (value) {
        this.value = value;
        if (this.signaturePad) {
            this.signaturePad.clear();
            if (this.value != value && this.innerValue) {
                this.signaturePad.fromDataURL(this.innerValue);
                this.isEmpty = false;
            }
        }
    };
    SignatureComponent.prototype.ngAfterViewInit = function () {
        _super.prototype.ngAfterViewInit.call(this);
        var options = {};
        if (this.color) {
            options['penColor'] = this.color;
        }
        if (this.backgroundColor) {
            options['backgroundColor'] = this.backgroundColor;
        }
        this.canvas = this.container.nativeElement.querySelector('canvas');
        this.signaturePad = new (require('signature_pad')['default'] || require('signature_pad'))(this.canvas, options);
        window.addEventListener("resize", this.resizeCanvas.bind(this), false);
        setTimeout(this.resizeCanvas.bind(this), 0);
    };
    SignatureComponent.prototype.resizeCanvas = function () {
        var ratio = Math.max(window.devicePixelRatio || 1, 1);
        this.canvas.width = this.container.nativeElement.clientWidth * ratio;
        this.canvas.height = this.container.nativeElement.clientHeight * ratio;
        this.canvas.getContext('2d').scale(ratio, ratio);
        if (this.signaturePad) {
            this.signaturePad.clear();
            if (this.innerValue) {
                this.signaturePad.fromDataURL(this.innerValue);
                this.isEmpty = false;
            }
        }
    };
    SignatureComponent.prototype.onClear = function () {
        this.isEmpty = true;
        this.signaturePad.clear();
        this.value = null;
        this.onChange(null);
    };
    SignatureComponent.prototype.ngOnDestroy = function () {
        window.removeEventListener("resize", this.resizeCanvas, false);
    };
    var SignatureComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], SignatureComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], SignatureComponent.prototype, "color", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], SignatureComponent.prototype, "backgroundColor", void 0);
    __decorate([
        core_1.ViewChild('container'),
        __metadata("design:type", core_1.ElementRef)
    ], SignatureComponent.prototype, "container", void 0);
    SignatureComponent = SignatureComponent_1 = __decorate([
        core_1.Component({
            selector: 'rz-signature',
            styles: [],
            template: "\n  <div #container [ngStyle]=\"style\" class=\"ui-signature ui-widget\" [ngClass]=\"{'ui-state-disabled': disabled}\">\n    <button *ngIf=\"!isEmpty\" type=\"button\" icon=\"ui-icon-trash\" class=\"pi pi-times\" pButton (click)=\"onClear()\"></button>\n    <input type=\"hidden\" [(ngModel)]=\"value\" />\n    <canvas></canvas>\n  </div>\n  ",
            providers: [
                {
                    provide: forms_1.NG_VALUE_ACCESSOR,
                    useExisting: core_1.forwardRef(function () { return SignatureComponent_1; }),
                    multi: true
                },
                {
                    provide: template_form_1.InputComponent,
                    useExisting: core_1.forwardRef(function () { return SignatureComponent_1; })
                }
            ]
        }),
        __param(0, core_1.Optional()), __param(0, core_1.Host()),
        __metadata("design:paramtypes", [template_form_1.TemplateFormComponent])
    ], SignatureComponent);
    return SignatureComponent;
}(template_form_1.InputComponent));
exports.SignatureComponent = SignatureComponent;
var SignatureModule = /** @class */ (function () {
    function SignatureModule() {
    }
    SignatureModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, forms_1.FormsModule, button_1.ButtonModule],
            declarations: [SignatureComponent],
            exports: [SignatureComponent]
        })
    ], SignatureModule);
    return SignatureModule;
}());
exports.SignatureModule = SignatureModule;
