"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var StepsItemComponent = /** @class */ (function () {
    function StepsItemComponent() {
        this.selected = false;
        this.disabled = false;
    }
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], StepsItemComponent.prototype, "text", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], StepsItemComponent.prototype, "selected", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], StepsItemComponent.prototype, "disabled", void 0);
    StepsItemComponent = __decorate([
        core_1.Component({
            selector: 'rz-steps-item',
            template: "\n    <div *ngIf=\"selected\" class=\"ui-widget-content\">\n      <ng-content></ng-content>\n    </div>\n  "
        })
    ], StepsItemComponent);
    return StepsItemComponent;
}());
exports.StepsItemComponent = StepsItemComponent;
var StepsComponent = /** @class */ (function () {
    function StepsComponent() {
        this.style = {};
        this.nextText = 'Next';
        this.previousText = 'Previous';
        this.change = new core_1.EventEmitter();
        this.selection = 0;
    }
    Object.defineProperty(StepsComponent.prototype, "selectedIndex", {
        get: function () {
            return this.selection;
        },
        set: function (selectedIndex) {
            this.selection = selectedIndex;
            if (this.steps) {
                this.steps.forEach(function (step, index) {
                    step.selected = index === selectedIndex;
                });
            }
        },
        enumerable: true,
        configurable: true
    });
    StepsComponent.prototype.ngAfterContentInit = function () {
        var _this = this;
        this.createItems();
        this.subscription = this.steps.changes.subscribe(function () { return _this.createItems(); });
    };
    StepsComponent.prototype.ngOnDestroy = function () {
        this.subscription.unsubscribe();
    };
    StepsComponent.prototype.createItems = function () {
        var _this = this;
        this.steps.forEach(function (step, index) {
            step.selected = index === _this.selectedIndex;
        });
    };
    StepsComponent.prototype.canNavigateTo = function (index) {
        if (!this.steps) {
            return false;
        }
        var steps = this.steps.toArray();
        var step = steps[index];
        if (!step) {
            return false;
        }
        return step.disabled != true;
    };
    StepsComponent.prototype.select = function (index) {
        if (this.canNavigateTo(index)) {
            this.selectedIndex = index;
            this.change.next({
                index: this.selectedIndex
            });
        }
    };
    StepsComponent.prototype.onItemClick = function (event, index) {
        event.preventDefault();
        this.select(index);
    };
    StepsComponent.prototype.onPreviousClick = function (event) {
        event.preventDefault();
        this.select(this.selectedIndex - 1);
    };
    StepsComponent.prototype.onNextClick = function (event) {
        event.preventDefault();
        this.select(this.selectedIndex + 1);
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], StepsComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number),
        __metadata("design:paramtypes", [Number])
    ], StepsComponent.prototype, "selectedIndex", null);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], StepsComponent.prototype, "nextText", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], StepsComponent.prototype, "previousText", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], StepsComponent.prototype, "change", void 0);
    __decorate([
        core_1.ContentChildren(StepsItemComponent),
        __metadata("design:type", core_1.QueryList)
    ], StepsComponent.prototype, "steps", void 0);
    StepsComponent = __decorate([
        core_1.Component({
            selector: 'rz-steps',
            template: "\n    <div stopChangePropagation [ngStyle]=\"style\">\n      <div class=\"ui-steps ui-widget ui-helper-clearfix\">\n        <ul role=\"tablist\">\n          <li\n            *ngFor=\"let item of steps; let i = index\"\n            class=\"ui-steps-item\"\n            [ngClass]=\"{\n              'ui-state-highlight ui-steps-current': item.selected,\n              'ui-state-default': !item.selected,\n              'ui-state-disabled': item.disabled\n            }\"\n          >\n            <a class=\"ui-menuitem-link\" (click)=\"onItemClick($event, i)\">\n              <span class=\"ui-steps-number\">{{ i + 1 }}</span>\n              <span class=\"ui-steps-title\">{{ item.text }}</span>\n            </a>\n          </li>\n        </ul>\n      </div>\n      <ng-content></ng-content>\n      <div class=\"ui-steps-buttons\">\n        <a\n          class=\"ui-steps-prev\"\n          [class.ui-state-disabled]=\"!canNavigateTo(selectedIndex - 1)\"\n          (click)=\"onPreviousClick($event)\"\n          ><i class=\"material-icons\">navigate_before</i>{{ previousText }}</a\n        >\n        <a\n          class=\"ui-steps-next\"\n          [class.ui-state-disabled]=\"!canNavigateTo(selectedIndex + 1)\"\n          (click)=\"onNextClick($event)\"\n          >{{ nextText }}<i class=\"material-icons\">navigate_next</i></a\n        >\n      </div>\n    </div>\n  "
        })
    ], StepsComponent);
    return StepsComponent;
}());
exports.StepsComponent = StepsComponent;
var StepsModule = /** @class */ (function () {
    function StepsModule() {
    }
    StepsModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule],
            declarations: [StepsComponent, StepsItemComponent],
            exports: [StepsComponent, StepsItemComponent]
        })
    ], StepsModule);
    return StepsModule;
}());
exports.StepsModule = StepsModule;
