"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var tabview_1 = require("primeng/tabview");
var TabsItemComponent = /** @class */ (function () {
    function TabsItemComponent() {
        this.visible = true;
        this.disabled = false;
    }
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], TabsItemComponent.prototype, "text", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], TabsItemComponent.prototype, "icon", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], TabsItemComponent.prototype, "selected", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], TabsItemComponent.prototype, "visible", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], TabsItemComponent.prototype, "disabled", void 0);
    __decorate([
        core_1.ViewChild(core_1.TemplateRef),
        __metadata("design:type", core_1.TemplateRef)
    ], TabsItemComponent.prototype, "template", void 0);
    TabsItemComponent = __decorate([
        core_1.Component({
            selector: 'rz-tabs-item',
            template: "\n    <ng-template><ng-content></ng-content></ng-template>\n  "
        })
    ], TabsItemComponent);
    return TabsItemComponent;
}());
exports.TabsItemComponent = TabsItemComponent;
var TabsComponent = /** @class */ (function () {
    function TabsComponent(elementRef) {
        this.elementRef = elementRef;
        this.style = {};
        this.change = new core_1.EventEmitter();
    }
    TabsComponent.prototype.ngAfterViewInit = function () {
        var tabs = this.items.toArray();
        for (var index = 0; index < tabs.length; index++) {
            var tab = tabs[index];
            if (tab.icon) {
                var icon = this.elementRef.nativeElement.querySelector(".ui-tabview-nav > li:nth-child(" + (index + 1) + ") .ui-tabview-left-icon");
                if (icon) {
                    icon.innerText = tab.icon;
                }
            }
        }
    };
    TabsComponent.prototype.onChange = function (event) {
        this.change.next({
            index: event.index
        });
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], TabsComponent.prototype, "selectedIndex", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], TabsComponent.prototype, "style", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], TabsComponent.prototype, "change", void 0);
    __decorate([
        core_1.ContentChildren(TabsItemComponent),
        __metadata("design:type", core_1.QueryList)
    ], TabsComponent.prototype, "items", void 0);
    TabsComponent = __decorate([
        core_1.Component({
            selector: 'rz-tabs',
            template: "\n    <p-tabView\n      stopChangePropagation\n      [style]=\"style\"\n      (onChange)=\"onChange($event)\"\n      [activeIndex]=\"selectedIndex\"\n    >\n      <ng-container *ngFor=\"let item of items\">\n        <p-tabPanel\n          *ngIf=\"item.visible\"\n          [leftIcon]=\"item.icon ? 'material-icons' : null\"\n          [header]=\"item.text\"\n          [disabled]=\"item.disabled\"\n          [selected]=\"item.selected\"\n        >\n          <ng-container *ngTemplateOutlet=\"item.template\"></ng-container>\n        </p-tabPanel>\n      </ng-container>\n    </p-tabView>\n  "
        }),
        __metadata("design:paramtypes", [core_1.ElementRef])
    ], TabsComponent);
    return TabsComponent;
}());
exports.TabsComponent = TabsComponent;
var TabsModule = /** @class */ (function () {
    function TabsModule() {
    }
    TabsModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, tabview_1.TabViewModule],
            declarations: [TabsComponent, TabsItemComponent],
            exports: [TabsComponent, TabsItemComponent]
        })
    ], TabsModule);
    return TabsModule;
}());
exports.TabsModule = TabsModule;
