import { QueryList, EventEmitter } from '@angular/core';
import { NgForm, NgModel, ControlValueAccessor } from '@angular/forms';
import { ValidatorComponent } from './validator';
export declare abstract class InputComponent<T> implements ControlValueAccessor {
    templateForm: TemplateFormComponent;
    name: string;
    disabled: boolean;
    change: EventEmitter<any>;
    ngModel: NgModel;
    value: T;
    protected innerValue: T;
    private validators;
    onChange: (value: T) => void;
    onTouched: () => void;
    writeValue(value: T): void;
    registerOnChange(fn: (value: T) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    registerValidator(validator: ValidatorComponent): void;
    ngAfterViewInit(): void;
    constructor(templateForm: TemplateFormComponent);
}
export declare class TemplateFormComponent {
    private ngUnsubscribe;
    style: any;
    submit: EventEmitter<any>;
    ngForm: NgForm;
    components: QueryList<InputComponent<any>>;
    fields: any[];
    readonly valid: boolean;
    onSubmit(event: Event): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
}
export declare class TemplateFormModule {
}
export declare function hideTemplateFromTemplateForm(): {
    provide: typeof TemplateFormComponent;
    useValue: any;
};
