"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var document_token_1 = require("./document.token");
var template_form_1 = require("./template-form");
var ValidatorService = /** @class */ (function () {
    function ValidatorService() {
        this.map = new WeakMap();
    }
    ValidatorService.prototype.setContext = function (data) {
        if (!this.map.has(data)) {
            this.map.set(data, []);
        }
        this.controls = this.map.get(data);
    };
    ValidatorService.prototype.deleteContext = function (data) {
        this.map.delete(data);
        this.controls = null;
    };
    ValidatorService.prototype.valid = function (data) {
        var controls = this.map.get(data);
        if (!controls) {
            return true;
        }
        var valid = true;
        controls.forEach(function (control) {
            control.markAsTouched();
            valid = valid && control.valid;
        });
        return valid;
    };
    ValidatorService.prototype.addControl = function (control) {
        if (this.controls) {
            this.controls.push(control);
        }
    };
    ValidatorService = __decorate([
        core_1.Injectable()
    ], ValidatorService);
    return ValidatorService;
}());
exports.ValidatorService = ValidatorService;
var ValidatorComponent = /** @class */ (function () {
    function ValidatorComponent(token, form, validatorService) {
        this.token = token;
        this.form = form;
        this.validatorService = validatorService;
    }
    Object.defineProperty(ValidatorComponent.prototype, "component", {
        set: function (component) {
            if (component instanceof template_form_1.InputComponent) {
                component.registerValidator(this);
            }
        },
        enumerable: true,
        configurable: true
    });
    ValidatorComponent.prototype.applyTo = function (control) {
        var _this = this;
        var validator = control.validator;
        control.setValidators(forms_1.Validators.compose([
            validator,
            function (control) { return _this.validate(control); }
        ]));
        this.control = control;
        if (this.validatorService) {
            this.validatorService.addControl(control);
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ValidatorComponent.prototype, "popup", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], ValidatorComponent.prototype, "style", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", template_form_1.InputComponent),
        __metadata("design:paramtypes", [template_form_1.InputComponent])
    ], ValidatorComponent.prototype, "component", null);
    ValidatorComponent = __decorate([
        __param(0, core_1.Optional()),
        __param(0, core_1.Inject(document_token_1.DOCUMENT_TOKEN)),
        __param(1, core_1.Host()),
        __param(1, core_1.Optional()),
        __param(2, core_1.Optional()),
        __metadata("design:paramtypes", [Object, template_form_1.TemplateFormComponent,
            ValidatorService])
    ], ValidatorComponent);
    return ValidatorComponent;
}());
exports.ValidatorComponent = ValidatorComponent;
